# ---------------------------------------------------------------------- #
# Script generated with: DeZign for Databases v5.2.3                     #
# Target DBMS:           MySQL 5                                         #
# Project file:          DBS3.dez                                        #
# Project name:          DBS3                                            #
# Author:                Yuyi Guo for DBS Group                          #
# Script type:           Database creation script                        #
# Created on:            2009-09-10 09:42                                #
# Model version:         Version 2009-09-10                              #
# ---------------------------------------------------------------------- #


CREATE ROLE CMS_DBS3_READ_ROLE;
CREATE ROLE CMS_DBS3_WRITE_ROLE;
CREATE ROLE CMS_DBS3_ADMIN_ROLE;
GRANT CMS_DBS3_READ_ROLE TO CMS_DBS3_READER;
GRANT CMS_DBS3_READ_ROLE, CMS_DBS3_WRITE_ROLE TO CMS_DBS3_WRITER;
GRANT CMS_DBS3_READ_ROLE, CMS_DBS3_WRITE_ROLE, CMS_DBS3_ADMIN_ROLE TO CMS_DBS3_ADMIN;

# ---------------------------------------------------------------------- #
# Tables                                                                 #
# ---------------------------------------------------------------------- #

# ---------------------------------------------------------------------- #
# Add table "APPLICATION_EXECUTABLES"                                    #
# ---------------------------------------------------------------------- #

CREATE TABLE `APPLICATION_EXECUTABLES` (
    `APP_EXEC_ID` INTEGER NOT NULL,
    `APP_NAME` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_AE` PRIMARY KEY (`APP_EXEC_ID`),
    CONSTRAINT `TUC_AE_APP_NAME` UNIQUE (`APP_NAME`)
);
GRANT SELECT ON APPLICATION_EXECUTABLES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON APPLICATION_EXECUTABLES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON APPLICATION_EXECUTABLES TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "RELEASE_VERSIONS"                                           #
# ---------------------------------------------------------------------- #

CREATE TABLE `RELEASE_VERSIONS` (
    `RELEASE_VERSION_ID` INTEGER NOT NULL,
    `VERSION` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_RV` PRIMARY KEY (`RELEASE_VERSION_ID`),
    CONSTRAINT `TUC_RV_VERSION` UNIQUE (`VERSION`)
);
GRANT SELECT ON RELEASE_VERSIONS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON RELEASE_VERSIONS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON RELEASE_VERSIONS TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PROCESSED_DATASETS"                                         #
# ---------------------------------------------------------------------- #

CREATE TABLE `PROCESSED_DATASETS` (
    `PROCESSED_DS_ID` INTEGER NOT NULL,
    `PROCESSED_DS_NAME` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_PSDS` PRIMARY KEY (`PROCESSED_DS_ID`),
    CONSTRAINT `TUC_PSDS_PROCESSED_DS_NAME` UNIQUE (`PROCESSED_DS_NAME`)
);
GRANT SELECT ON PROCESSED_DATASETS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PROCESSED_DATASETS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PROCESSED_DATASETS TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "BRANCH_HASHES"                                              #
# ---------------------------------------------------------------------- #

CREATE TABLE `BRANCH_HASHES` (
    `BRANCH_HASH_ID` INTEGER NOT NULL,
    `HASH` VARCHAR(700) NOT NULL,
    `CONTENT` LONGBLOB,
    CONSTRAINT `PK_BH` PRIMARY KEY (`BRANCH_HASH_ID`)
);
GRANT SELECT ON BRANCH_HASHES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON BRANCH_HASHES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON BRANCH_HASHES TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "FILE_TYPES"                                                 #
# ---------------------------------------------------------------------- #

CREATE TABLE `FILE_TYPES` (
    `FILE_TYPE_ID` INTEGER NOT NULL,
    `FILE_TYPE` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_FT` PRIMARY KEY (`FILE_TYPE_ID`),
    CONSTRAINT `TUC_FT_FILE_TYPE` UNIQUE (`FILE_TYPE`)
);
GRANT SELECT ON FILE_TYPES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON FILE_TYPES  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON FILE_TYPES  TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PHYSICS_GROUPS"                                             #
# ---------------------------------------------------------------------- #

CREATE TABLE `PHYSICS_GROUPS` (
    `PHYSICS_GROUP_ID` INTEGER NOT NULL,
    `PHYSICS_GROUP_NAME` VARCHAR(100) NOT NULL,
    `PHYSICS_GROUP_CONVENER` VARCHAR(100),
    CONSTRAINT `PK_PG` PRIMARY KEY (`PHYSICS_GROUP_ID`),
    CONSTRAINT `TUC_PG_PHYSICS_GROUP_NAME` UNIQUE (`PHYSICS_GROUP_NAME`)
);
GRANT SELECT ON PHYSICS_GROUPS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PHYSICS_GROUPS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PHYSICS_GROUPS TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PRIMARY_DS_TYPES"                                           #
# ---------------------------------------------------------------------- #

CREATE TABLE `PRIMARY_DS_TYPES` (
    `PRIMARY_DS_TYPE_ID` INTEGER NOT NULL,
    `PRIMARY_DS_TYPE` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_PDT` PRIMARY KEY (`PRIMARY_DS_TYPE_ID`),
    CONSTRAINT `TUC_PDT_PRIMARY_DS_TYPE` UNIQUE (`PRIMARY_DS_TYPE`)
);
GRANT SELECT ON PRIMARY_DS_TYPES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PRIMARY_DS_TYPES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PRIMARY_DS_TYPES TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PATH_TYPES"                                                 #
# ---------------------------------------------------------------------- #

CREATE TABLE `PATH_TYPES` (
    `PATH_TYPE_ID` INTEGER NOT NULL,
    `PATH_TYPE` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_PT` PRIMARY KEY (`PATH_TYPE_ID`),
    CONSTRAINT `TUC_PT_PATH_TYPE` UNIQUE (`PATH_TYPE`)
);
GRANT SELECT ON PATH_TYPES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PATH_TYPES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PATH_TYPES TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PARAMETER_SET_HASHES"                                       #
# ---------------------------------------------------------------------- #

CREATE TABLE `PARAMETER_SET_HASHES` (
    `PARAMETER_SET_HASH_ID` INTEGER NOT NULL,
    `HASH` VARCHAR(64) NOT NULL,
    `NAME` VARCHAR(45),
    CONSTRAINT `PK_PSH` PRIMARY KEY (`PARAMETER_SET_HASH_ID`),
    CONSTRAINT `TUC_PSH_HASH` UNIQUE (`HASH`)
);
GRANT SELECT ON PARAMETER_SET_HASHES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PARAMETER_SET_HASHES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PARAMETER_SET_HASHES TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_PSH_1` ON `PARAMETER_SET_HASHES` (`NAME`);

# ---------------------------------------------------------------------- #
# Add table "DBS_VERSIONS"                                               #
# ---------------------------------------------------------------------- #

CREATE TABLE `DBS_VERSIONS` (
    `DBS_VERSION_ID` INTEGER NOT NULL,
    `SCHEMA_VERSION` VARCHAR(40) NOT NULL,
    `DBS_RELEASE_VERSION` VARCHAR(40) NOT NULL,
    `INSTANCE_NAME` VARCHAR(40) NOT NULL,
    `INSTANCE_TYPE` VARCHAR(40) NOT NULL,
    `CREATION_DATE` INTEGER,
    `LAST_MODIFICATION_DATE` INTEGER,
    CONSTRAINT `PK_DV` PRIMARY KEY (`DBS_VERSION_ID`)
);
GRANT SELECT ON DBS_VERSIONS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON DBS_VERSIONS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON DBS_VERSIONS TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "SITES"                                                      #
# ---------------------------------------------------------------------- #

CREATE TABLE `SITES` (
    `SITE_ID` INTEGER NOT NULL,
    `SITE_NAME` VARCHAR(100) NOT NULL,
    CONSTRAINT `PK_SI` PRIMARY KEY (`SITE_ID`),
    CONSTRAINT `TUC_SI_SITE_NAME` UNIQUE (`SITE_NAME`)
);
GRANT SELECT ON SITES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON SITES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON SITES TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PROCESS_CONFIGURATIONS"                                     #
# ---------------------------------------------------------------------- #

CREATE TABLE `PROCESS_CONFIGURATIONS` (
    `PROCESS_CONFIG_ID` INTEGER NOT NULL,
    `APP_EXEC_ID` INTEGER NOT NULL,
    `RELEASE_VERSION_ID` INTEGER NOT NULL,
    `PARAMETER_SET_HASH_ID` INTEGER NOT NULL,
    `OUTPUT_MODULE_LABEL` VARCHAR(45) NOT NULL DEFAULT 'NONE',
    `CREATION_DATE` INTEGER,
    `CREATE_BY` VARCHAR(100),
    CONSTRAINT `PK_PC` PRIMARY KEY (`PROCESS_CONFIG_ID`),
    CONSTRAINT `TUC_PC_1` UNIQUE (`APP_EXEC_ID`, `RELEASE_VERSION_ID`, `PARAMETER_SET_HASH_ID`, `OUTPUT_MODULE_LABEL`)
);
GRANT SELECT ON PROCESS_CONFIGURATIONS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PROCESS_CONFIGURATIONS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PROCESS_CONFIGURATIONS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `ID_PC_1` ON `PROCESS_CONFIGURATIONS` (`RELEASE_VERSION_ID`);

CREATE INDEX `ID_PC_2` ON `PROCESS_CONFIGURATIONS` (`PARAMETER_SET_HASH_ID`);

CREATE INDEX `ID_PC_3` ON `PROCESS_CONFIGURATIONS` (`OUTPUT_MODULE_LABEL`);

CREATE INDEX `ID_PC_4` ON `PROCESS_CONFIGURATIONS` (`APP_EXEC_ID`);

# ---------------------------------------------------------------------- #
# Add table "DATA_TIERS"                                                 #
# ---------------------------------------------------------------------- #

CREATE TABLE `DATA_TIERS` (
    `DATA_TIER_ID` INTEGER NOT NULL,
    `DATA_TIER_NAME` VARCHAR(100) NOT NULL,
    `CREATION_DATE` INTEGER,
    `CREATE_BY` VARCHAR(100),
    CONSTRAINT `PK_DT` PRIMARY KEY (`DATA_TIER_ID`),
    CONSTRAINT `TUC_DT_DATA_TIER_NAME` UNIQUE (`DATA_TIER_NAME`)
);
GRANT SELECT ON DATA_TIERS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON DATA_TIERS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON DATA_TIERS TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PRIMARY_DATASETS"                                           #
# ---------------------------------------------------------------------- #

CREATE TABLE `PRIMARY_DATASETS` (
    `PRIMARY_DS_ID` INTEGER NOT NULL,
    `PRIMARY_DS_NAME` VARCHAR(100) NOT NULL,
    `PRIMARY_DS_TYPE_ID` INTEGER NOT NULL,
    `CREATION_DATE` INTEGER,
    `CREATE_BY` VARCHAR(100),
    CONSTRAINT `PK_PDS` PRIMARY KEY (`PRIMARY_DS_ID`),
    CONSTRAINT `TUC_PDS_PRIMARY_DS_NAME` UNIQUE (`PRIMARY_DS_NAME`)
);
GRANT SELECT ON PRIMARY_DATASETS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PRIMARY_DATASETS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PRIMARY_DATASETS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_PDS_1` ON `PRIMARY_DATASETS` (`PRIMARY_DS_TYPE_ID`);

# ---------------------------------------------------------------------- #
# Add table "PATHS"                                                      #
# ---------------------------------------------------------------------- #

CREATE TABLE `PATHS` (
    `PATH_ID` INTEGER NOT NULL,
    `PATH_NAME` VARCHAR(500) NOT NULL,
    `IS_PATH_VALID` NUMERIC(1) NOT NULL DEFAULT 1,
    `PRIMARY_DS_ID` INTEGER NOT NULL,
    `PROCESSED_DS_ID` INTEGER NOT NULL,
    `DATA_TIER_ID` INTEGER NOT NULL,
    `PATH_TYPE_ID` INTEGER NOT NULL,
    `ACQUISITION_ERA_ID` INTEGER,
    `PROCESSING_ERA_ID` INTEGER,
    `PHYSICS_GROUP_ID` INTEGER,
    `XTCROSSSECTION` FLOAT(126,0),
    `GLOBAL_TAG` VARCHAR(255),
    `CREATIONDATE` INTEGER,
    `CREATEBY` VARCHAR(100),
    `LASTMODIFICATIONDATE` INTEGER,
    `LASTMODIFIEDBY` VARCHAR(100),
    CONSTRAINT `PK_PH` PRIMARY KEY (`PATH_ID`),
    CONSTRAINT `TUC_PH_PATH_NAME` UNIQUE (`PATH_NAME`)
);
GRANT SELECT ON PATHS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PATHS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PATHS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_PH_1` ON `PATHS` (`PRIMARY_DS_ID`);

CREATE INDEX `IDX_PH_2` ON `PATHS` (`DATA_TIER_ID`);

CREATE INDEX `IDX_PH_3` ON `PATHS` (`PROCESSED_DS_ID`);

CREATE INDEX `IDX_PH_4` ON `PATHS` (`PATH_TYPE_ID`);

CREATE INDEX `IDX_PH_5` ON `PATHS` (`PHYSICS_GROUP_ID`);

CREATE INDEX `IDX_PH_6` ON `PATHS` (`ACQUISITION_ERA_ID`);

CREATE INDEX `IDX_PH_7` ON `PATHS` (`PROCESSING_ERA_ID`);

CREATE INDEX `ID_PH_8` ON `PATHS` (`CREATIONDATE`);

CREATE INDEX `ID_PH_9` ON `PATHS` (`CREATEBY`);

ALTER TABLE `PATHS` ADD CONSTRAINT `CC_PH_IS_PATH_VALID` 
    CHECK (IS_PATH_VALID in (1,0));

# ---------------------------------------------------------------------- #
# Add table "BLOCKS"                                                     #
# ---------------------------------------------------------------------- #

CREATE TABLE `BLOCKS` (
    `BLOCK_ID` INTEGER NOT NULL,
    `BLOCK_NAME` VARCHAR(500) NOT NULL,
    `PATH_ID` INTEGER NOT NULL,
    `OPEN_FOR_WRITING` NUMERIC(1) NOT NULL DEFAULT 1,
    `ORIGIN_SITE` INTEGER,
    `BLOCK_SIZE` INTEGER,
    `FILE_COUNT` INTEGER,
    `CREATION_DATE` INTEGER,
    `CREATE_BY` VARCHAR(100),
    `LAST_MODIFICATION_DATE` INTEGER,
    `LAST_MODIFIED_BY` VARCHAR(100),
    CONSTRAINT `PK_BK` PRIMARY KEY (`BLOCK_ID`),
    CONSTRAINT `TUC_BK_BLOCK_NAME` UNIQUE (`BLOCK_NAME`)
);
GRANT SELECT ON BLOCKS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON BLOCKS  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON BLOCKS  TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_BK_1` ON `BLOCKS` (`PATH_ID`);

CREATE INDEX `IDX_BK_2` ON `BLOCKS` (`ORIGIN_SITE`);

CREATE INDEX `ID_BK_3` ON `BLOCKS` (`BLOCK_SIZE`);

CREATE INDEX `ID_BK_4` ON `BLOCKS` (`FILE_COUNT`);

CREATE INDEX `ID_BK_5` ON `BLOCKS` (`CREATION_DATE`);

CREATE INDEX `ID_BK_6` ON `BLOCKS` (`CREATE_BY`);

ALTER TABLE `BLOCKS` ADD CONSTRAINT `CC_BK_OPEN_FOR_WRITING` 
    CHECK (OPEN_FOR_WRITING IN (1,0));

# ---------------------------------------------------------------------- #
# Add table "BLOCK_PARENTS"                                              #
# ---------------------------------------------------------------------- #

CREATE TABLE `BLOCK_PARENTS` (
    `BLOCK_PARENT_ID` INTEGER NOT NULL,
    `THIS_BLOCK_ID` INTEGER NOT NULL,
    `PARENT_BLOCK_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_BP` PRIMARY KEY (`BLOCK_PARENT_ID`)
);
GRANT SELECT ON BLOCK_PARENTS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON BLOCK_PARENTS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON BLOCK_PARENTS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_BP_1` ON `BLOCK_PARENTS` (`THIS_BLOCK_ID`);

CREATE INDEX `IDX_BP_2` ON `BLOCK_PARENTS` (`PARENT_BLOCK_ID`);

# ---------------------------------------------------------------------- #
# Add table "FILES"                                                      #
# ---------------------------------------------------------------------- #

CREATE TABLE `FILES` (
    `FILE_ID` INTEGER NOT NULL,
    `LOGICAL_FILE_NAME` VARCHAR(500) NOT NULL,
    `IS_FILE_VALID` NUMERIC(1) NOT NULL DEFAULT 1,
    `PATH_ID` INTEGER NOT NULL,
    `BLOCK_ID` INTEGER NOT NULL,
    `FILE_TYPE_ID` INTEGER NOT NULL,
    `CHECK_SUM` VARCHAR(100) NOT NULL,
    `EVENT_COUNT` INTEGER NOT NULL,
    `FILE_SIZE` INTEGER NOT NULL,
    `BRANCH_HASH_ID` INTEGER,
    `ADLER32` VARCHAR(100) DEFAULT 'NOTSET',
    `MD5` VARCHAR(100) DEFAULT 'NOTSET',
    `AUTO_CROSS_SECTION` FLOAT(126,0),
    `CREATION_DATE` INTEGER,
    `CREATE_BY` VARCHAR(100),
    `LASTMODIFICATIONDATE` INTEGER,
    `LAST_MODIFIED_BY` VARCHAR(100),
    CONSTRAINT `PK_FL` PRIMARY KEY (`FILE_ID`),
    CONSTRAINT `TUC_FL_LOGICAL_FILE_NAME` UNIQUE (`LOGICAL_FILE_NAME`)
);
GRANT SELECT ON FILES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON FILES  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON FILES  TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_FL_1` ON `FILES` (`PATH_ID`);

CREATE INDEX `IDX_FL_2` ON `FILES` (`BLOCK_ID`);

CREATE INDEX `IDX_FL_3` ON `FILES` (`FILE_TYPE_ID`);

CREATE INDEX `IDX_FL_4` ON `FILES` (`BRANCH_HASH_ID`);

CREATE INDEX `IDX_FL_5` ON `FILES` (`FILE_SIZE`);

CREATE INDEX `IDX_FL_6` ON `FILES` (`CREATION_DATE`);

CREATE INDEX `IDX_FL_7` ON `FILES` (`CREATE_BY`);

ALTER TABLE `FILES` ADD CONSTRAINT `CC_FL_IS_FILE_VALID` 
    CHECK (IS_FILE_VALID in (1,0));

# ---------------------------------------------------------------------- #
# Add table "PATH_PROCESS_CONFIGS"                                       #
# ---------------------------------------------------------------------- #

CREATE TABLE `PATH_PROCESS_CONFIGS` (
    `PATH_PROCESS_CONF_ID` INTEGER NOT NULL,
    `PATH_ID` INTEGER NOT NULL,
    `PROCESS_CONFIG_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_PPC` PRIMARY KEY (`PATH_PROCESS_CONF_ID`)
);
GRANT SELECT ON PATH_PROCESS_CONFIGS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PATH_PROCESS_CONFIGS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PATH_PROCESS_CONFIGS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_PPC_1` ON `PATH_PROCESS_CONFIGS` (`PATH_ID`);

CREATE INDEX `IDX_PPC_2` ON `PATH_PROCESS_CONFIGS` (`PROCESS_CONFIG_ID`);

# ---------------------------------------------------------------------- #
# Add table "PATH_PARENTS"                                               #
# ---------------------------------------------------------------------- #

CREATE TABLE `PATH_PARENTS` (
    `PATH_PARENT_ID` INTEGER NOT NULL,
    `THIS_PATH_ID` INTEGER NOT NULL,
    `PARENT_PATH_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_PP` PRIMARY KEY (`PATH_PARENT_ID`)
);
GRANT SELECT ON PATH_PARENTS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PATH_PARENTS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PATH_PARENTS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_PP_1` ON `PATH_PARENTS` (`THIS_PATH_ID`);

CREATE INDEX `IDX_PP_2` ON `PATH_PARENTS` (`PARENT_PATH_ID`);

# ---------------------------------------------------------------------- #
# Add table "PATH_RUNS"                                                  #
# ---------------------------------------------------------------------- #

CREATE TABLE `PATH_RUNS` (
    `PATH_RUN_ID` INTEGER NOT NULL,
    `PATH_ID` INTEGER NOT NULL,
    `RUN_NUMBER` INTEGER,
    `COMPLETE` INTEGER DEFAULT 0,
    `EVENT_COUNT` INTEGER,
    `LUMI_SECTION_COUNT` INTEGER,
    `CREATION_DATE` INTEGER,
    `CREATE_BY` VARCHAR(100),
    CONSTRAINT `PK_PR` PRIMARY KEY (`PATH_RUN_ID`)
);
GRANT SELECT ON PATH_RUNS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PATH_RUNS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PATH_RUNS TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_PR_1` ON `PATH_RUNS` (`PATH_ID`);

CREATE INDEX `IDX_PR_2` ON `PATH_RUNS` (`RUN_NUMBER`);

CREATE INDEX `IDX_PR_3` ON `PATH_RUNS` (`EVENT_COUNT`);

CREATE INDEX `IDX_PR_4` ON `PATH_RUNS` (`LUMI_SECTION_COUNT`);

# ---------------------------------------------------------------------- #
# Add table "FILE_PROCESS_CONFIGS"                                       #
# ---------------------------------------------------------------------- #

CREATE TABLE `FILE_PROCESS_CONFIGS` (
    `FILE_PROCESS_CONFIG_ID` INTEGER NOT NULL,
    `FILE_ID` INTEGER NOT NULL,
    `PROCESS_CONFIG_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_FPC` PRIMARY KEY (`FILE_PROCESS_CONFIG_ID`)
);
GRANT SELECT ON FILE_PROCESS_CONFIGS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON FILE_PROCESS_CONFIGS  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON FILE_PROCESS_CONFIGS  TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_FPC_1` ON `FILE_PROCESS_CONFIGS` (`FILE_ID`);

CREATE INDEX `IDX_FPC_2` ON `FILE_PROCESS_CONFIGS` (`PROCESS_CONFIG_ID`);

# ---------------------------------------------------------------------- #
# Add table "ASSOCIATED_FILES"                                           #
# ---------------------------------------------------------------------- #

CREATE TABLE `ASSOCIATED_FILES` (
    `ASSOCATED_FILE_ID` INTEGER NOT NULL,
    `THIS_FILE_ID` INTEGER NOT NULL,
    `ASSOCATED_FILE` INTEGER NOT NULL,
    CONSTRAINT `PK_AF` PRIMARY KEY (`ASSOCATED_FILE_ID`)
);
GRANT SELECT ON ASSOCIATED_FILES TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON ASSOCIATED_FILES TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON ASSOCIATED_FILES TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_AF_1` ON `ASSOCIATED_FILES` (`THIS_FILE_ID`);

CREATE INDEX `IDX_AF_2` ON `ASSOCIATED_FILES` (`ASSOCATED_FILE`);

# ---------------------------------------------------------------------- #
# Add table "FILE_PARENTS"                                               #
# ---------------------------------------------------------------------- #

CREATE TABLE `FILE_PARENTS` (
    `FILE_PARENT_ID` INTEGER NOT NULL,
    `THIS_FILE_ID` INTEGER NOT NULL,
    `PARENT_FILE_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_FP` PRIMARY KEY (`FILE_PARENT_ID`)
);
GRANT SELECT ON FILE_PARENTS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON FILE_PARENTS  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON FILE_PARENTS  TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_FP_1` ON `FILE_PARENTS` (`THIS_FILE_ID`);

CREATE INDEX `IDX_FP_2` ON `FILE_PARENTS` (`PARENT_FILE_ID`);

# ---------------------------------------------------------------------- #
# Add table "FILE_LUMIS"                                                 #
# ---------------------------------------------------------------------- #

CREATE TABLE `FILE_LUMIS` (
    `FILE_LUMI_ID` INTEGER NOT NULL,
    `RUN_NUM` INTEGER NOT NULL,
    `LUMI_SECTION_NUM` INTEGER NOT NULL,
    `FILE_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_FLM` PRIMARY KEY (`FILE_LUMI_ID`)
);
GRANT SELECT ON FILE_LUMIS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON FILE_LUMIS  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON FILE_LUMIS  TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_FLM_1` ON `FILE_LUMIS` (`FILE_ID`);

# ---------------------------------------------------------------------- #
# Add table "ACQUISITION_ERAS"                                           #
# ---------------------------------------------------------------------- #

CREATE TABLE `ACQUISITION_ERAS` (
    `ACQUISITION_ERA_ID` INTEGER NOT NULL,
    `ACQUISITION_ERA_NAME` VARCHAR(120) NOT NULL,
    CONSTRAINT `PK_AQE` PRIMARY KEY (`ACQUISITION_ERA_ID`),
    CONSTRAINT `TUC_AQE_ACQUISITION_ERA_NAME` UNIQUE (`ACQUISITION_ERA_NAME`)
);
GRANT SELECT ON ACQUISITION_ERAS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON ACQUISITION_ERAS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON ACQUISITION_ERAS TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "PROCESSING_ERAS"                                            #
# ---------------------------------------------------------------------- #

CREATE TABLE `PROCESSING_ERAS` (
    `PROCESSING_ERA_ID` INTEGER NOT NULL,
    `PROCESSING_ERA_NAME` VARCHAR(100),
    CONSTRAINT `PK_PE` PRIMARY KEY (`PROCESSING_ERA_ID`),
    CONSTRAINT `TUC_PE_PROCESSING_ERA_NAME` UNIQUE (`PROCESSING_ERA_NAME`)
);
GRANT SELECT ON PROCESSING_ERAS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON PROCESSING_ERAS  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON PROCESSING_ERAS  TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "STORAGE_ELEMENTS"                                           #
# ---------------------------------------------------------------------- #

CREATE TABLE `STORAGE_ELEMENTS` (
    `SE_ID` INTEGER NOT NULL,
    `SE_NAME` VARCHAR(500),
    CONSTRAINT `PK_SE` PRIMARY KEY (`SE_ID`),
    CONSTRAINT `TUC_SE_SE_NAME` UNIQUE (`SE_NAME`)
);
GRANT SELECT ON STORAGE_ELEMENTS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON STORAGE_ELEMENTS  TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON STORAGE_ELEMENTS  TO CMS_DBS3_ADMIN_ROLE;

# ---------------------------------------------------------------------- #
# Add table "BLOCK_STORAGE_ELEMENTS"                                     #
# ---------------------------------------------------------------------- #

CREATE TABLE `BLOCK_STORAGE_ELEMENTS` (
    `BLOCK_SE_ID` INTEGER NOT NULL,
    `SE_ID` INTEGER NOT NULL,
    `BLOCK_ID` INTEGER NOT NULL,
    CONSTRAINT `PK_BSE` PRIMARY KEY (`BLOCK_SE_ID`)
);
GRANT SELECT ON BLOCK_STORAGE_ELEMENTS TO CMS_DBS3_READ_ROLE;
GRANT INSERT, UPDATE ON BLOCK_STORAGE_ELEMENTS TO CMS_DBS3_WRITE_ROLE;
GRANT DELETE ON BLOCK_STORAGE_ELEMENTS  TO CMS_DBS3_ADMIN_ROLE;

CREATE INDEX `IDX_BSE_1` ON `BLOCK_STORAGE_ELEMENTS` (`SE_ID`);

CREATE INDEX `IDX_BSE_2` ON `BLOCK_STORAGE_ELEMENTS` (`BLOCK_ID`);

# ---------------------------------------------------------------------- #
# Foreign key constraints                                                #
# ---------------------------------------------------------------------- #

ALTER TABLE `PROCESS_CONFIGURATIONS` ADD CONSTRAINT `AE_PC` 
    FOREIGN KEY (`APP_EXEC_ID`) REFERENCES `APPLICATION_EXECUTABLES` (`APP_EXEC_ID`) ON DELETE CASCADE;

ALTER TABLE `PROCESS_CONFIGURATIONS` ADD CONSTRAINT `RV_PC` 
    FOREIGN KEY (`RELEASE_VERSION_ID`) REFERENCES `RELEASE_VERSIONS` (`RELEASE_VERSION_ID`) ON DELETE CASCADE;

ALTER TABLE `PROCESS_CONFIGURATIONS` ADD CONSTRAINT `PSH_PC` 
    FOREIGN KEY (`PARAMETER_SET_HASH_ID`) REFERENCES `PARAMETER_SET_HASHES` (`PARAMETER_SET_HASH_ID`) ON DELETE CASCADE;

ALTER TABLE `PRIMARY_DATASETS` ADD CONSTRAINT `PDT_PDS` 
    FOREIGN KEY (`PRIMARY_DS_TYPE_ID`) REFERENCES `PRIMARY_DS_TYPES` (`PRIMARY_DS_TYPE_ID`);

ALTER TABLE `PATHS` ADD CONSTRAINT `PDS_PH` 
    FOREIGN KEY (`PRIMARY_DS_ID`) REFERENCES `PRIMARY_DATASETS` (`PRIMARY_DS_ID`) ON DELETE CASCADE;

ALTER TABLE `PATHS` ADD CONSTRAINT `DT_PH` 
    FOREIGN KEY (`DATA_TIER_ID`) REFERENCES `DATA_TIERS` (`DATA_TIER_ID`) ON DELETE CASCADE;

ALTER TABLE `PATHS` ADD CONSTRAINT `PSDS_PH` 
    FOREIGN KEY (`PROCESSED_DS_ID`) REFERENCES `PROCESSED_DATASETS` (`PROCESSED_DS_ID`) ON DELETE CASCADE;

ALTER TABLE `PATHS` ADD CONSTRAINT `PT_PH` 
    FOREIGN KEY (`PATH_TYPE_ID`) REFERENCES `PATH_TYPES` (`PATH_TYPE_ID`);

ALTER TABLE `PATHS` ADD CONSTRAINT `PG_PH` 
    FOREIGN KEY (`PHYSICS_GROUP_ID`) REFERENCES `PHYSICS_GROUPS` (`PHYSICS_GROUP_ID`) ON DELETE SET NULL;

ALTER TABLE `PATHS` ADD CONSTRAINT `AQE_PH` 
    FOREIGN KEY (`ACQUISITION_ERA_ID`) REFERENCES `ACQUISITION_ERAS` (`ACQUISITION_ERA_ID`) ON DELETE SET NULL;

ALTER TABLE `PATHS` ADD CONSTRAINT `PE_PH` 
    FOREIGN KEY (`PROCESSING_ERA_ID`) REFERENCES `PROCESSING_ERAS` (`PROCESSING_ERA_ID`) ON DELETE SET NULL;

ALTER TABLE `BLOCKS` ADD CONSTRAINT `PH_BK` 
    FOREIGN KEY (`PATH_ID`) REFERENCES `PATHS` (`PATH_ID`) ON DELETE CASCADE;

ALTER TABLE `BLOCKS` ADD CONSTRAINT `SI_BK` 
    FOREIGN KEY (`ORIGIN_SITE`) REFERENCES `SITES` (`SITE_ID`) ON DELETE SET NULL;

ALTER TABLE `BLOCK_PARENTS` ADD CONSTRAINT `BK_BP` 
    FOREIGN KEY (`THIS_BLOCK_ID`) REFERENCES `BLOCKS` (`BLOCK_ID`) ON DELETE CASCADE;

ALTER TABLE `BLOCK_PARENTS` ADD CONSTRAINT `BK_BP2` 
    FOREIGN KEY (`PARENT_BLOCK_ID`) REFERENCES `BLOCKS` (`BLOCK_ID`) ON DELETE CASCADE;

ALTER TABLE `FILES` ADD CONSTRAINT `PH_FL` 
    FOREIGN KEY (`PATH_ID`) REFERENCES `PATHS` (`PATH_ID`) ON DELETE CASCADE;

ALTER TABLE `FILES` ADD CONSTRAINT `BK_FL` 
    FOREIGN KEY (`BLOCK_ID`) REFERENCES `BLOCKS` (`BLOCK_ID`) ON DELETE CASCADE;

ALTER TABLE `FILES` ADD CONSTRAINT `FT_FL` 
    FOREIGN KEY (`FILE_TYPE_ID`) REFERENCES `FILE_TYPES` (`FILE_TYPE_ID`);

ALTER TABLE `FILES` ADD CONSTRAINT `BH_FL` 
    FOREIGN KEY (`BRANCH_HASH_ID`) REFERENCES `BRANCH_HASHES` (`BRANCH_HASH_ID`) ON DELETE SET NULL;

ALTER TABLE `PATH_PROCESS_CONFIGS` ADD CONSTRAINT `PH_PPC` 
    FOREIGN KEY (`PATH_ID`) REFERENCES `PATHS` (`PATH_ID`) ON DELETE CASCADE;

ALTER TABLE `PATH_PROCESS_CONFIGS` ADD CONSTRAINT `PC_PPC` 
    FOREIGN KEY (`PROCESS_CONFIG_ID`) REFERENCES `PROCESS_CONFIGURATIONS` (`PROCESS_CONFIG_ID`) ON DELETE CASCADE;

ALTER TABLE `PATH_PARENTS` ADD CONSTRAINT `PH_PP` 
    FOREIGN KEY (`THIS_PATH_ID`) REFERENCES `PATHS` (`PATH_ID`) ON DELETE CASCADE;

ALTER TABLE `PATH_PARENTS` ADD CONSTRAINT `PH_PP2` 
    FOREIGN KEY (`PARENT_PATH_ID`) REFERENCES `PATHS` (`PATH_ID`) ON DELETE CASCADE;

ALTER TABLE `PATH_RUNS` ADD CONSTRAINT `PH_PR` 
    FOREIGN KEY (`PATH_ID`) REFERENCES `PATHS` (`PATH_ID`) ON DELETE CASCADE;

ALTER TABLE `FILE_PROCESS_CONFIGS` ADD CONSTRAINT `FL_FPC` 
    FOREIGN KEY (`FILE_ID`) REFERENCES `FILES` (`FILE_ID`) ON DELETE CASCADE;

ALTER TABLE `FILE_PROCESS_CONFIGS` ADD CONSTRAINT `PC_FPC` 
    FOREIGN KEY (`PROCESS_CONFIG_ID`) REFERENCES `PROCESS_CONFIGURATIONS` (`PROCESS_CONFIG_ID`) ON DELETE CASCADE;

ALTER TABLE `ASSOCIATED_FILES` ADD CONSTRAINT `FL_AF` 
    FOREIGN KEY (`THIS_FILE_ID`) REFERENCES `FILES` (`FILE_ID`) ON DELETE CASCADE;

ALTER TABLE `ASSOCIATED_FILES` ADD CONSTRAINT `FL_AF2` 
    FOREIGN KEY (`ASSOCATED_FILE`) REFERENCES `FILES` (`FILE_ID`) ON DELETE CASCADE;

ALTER TABLE `FILE_PARENTS` ADD CONSTRAINT `FL_FP` 
    FOREIGN KEY (`THIS_FILE_ID`) REFERENCES `FILES` (`FILE_ID`) ON DELETE CASCADE;

ALTER TABLE `FILE_PARENTS` ADD CONSTRAINT `FL_FP2` 
    FOREIGN KEY (`PARENT_FILE_ID`) REFERENCES `FILES` (`FILE_ID`) ON DELETE CASCADE;

ALTER TABLE `FILE_LUMIS` ADD CONSTRAINT `FL_FLM` 
    FOREIGN KEY (`FILE_ID`) REFERENCES `FILES` (`FILE_ID`) ON DELETE CASCADE;

ALTER TABLE `BLOCK_STORAGE_ELEMENTS` ADD CONSTRAINT `SE_BSE` 
    FOREIGN KEY (`SE_ID`) REFERENCES `STORAGE_ELEMENTS` (`SE_ID`) ON DELETE CASCADE;

ALTER TABLE `BLOCK_STORAGE_ELEMENTS` ADD CONSTRAINT `BK_BSE` 
    FOREIGN KEY (`BLOCK_ID`) REFERENCES `BLOCKS` (`BLOCK_ID`) ON DELETE CASCADE;

GRANT SELECT ON SEQ_AE TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_AF TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_AQE TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_BH TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_BK TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_BP TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_BSE TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_DT TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_DV TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_FL TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_FLM TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_FP TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_FPC TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_FT TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PC TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PDS TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PDT TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PE TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PG TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PH TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PP TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PPC TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PR TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PSDS TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PSH TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_PT TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_RV TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_SE TO CMS_DBS3_READ_ROLE;
GRANT SELECT ON SEQ_SI TO CMS_DBS3_READ_ROLE;
